#FLM: kern_test
f = fl.font
err = []

def Compar (Sym_, Sym_1, Sym_cyr, Sym_cyr1):
 g = f[Sym_]     #  .
 g1 = f[Sym_cyr] #  .
 if (g == None) or (g1 == None) or (f[Sym_1] == None) or (f[Sym_cyr1] == None):
 	return
     
 #     (.)
 n = -1	
 ind = f[Sym_1].index			 
 for i in range (len(g.kerning)):
   if g.kerning[i].key == ind: 
    k = g.kerning[i].value
    n = i
 if n == -1:
   print "/"+g.name,"/"+f[Sym_1].name, "---------- lat. pair not exist"
   return

#     (.)
 n = -1
 ind = f[Sym_cyr1].index	
 for i in range (len(g1.kerning)):
   if g1.kerning[i].key == ind: 
    k1 = g1.kerning[i].value
    n = i
 if n == -1:
   print g.name, f[Sym_1].name, "+++++++++ cyr. (greek) pair is added"
   g1.kerning.append(KerningPair(f[Sym_cyr1].index, k))
   err.append (1)
   return
  
# 
 if k != k1:
 	print g.name, f[Sym_1].name, "........... corrected"
 	g1.kerning[n].value = k
 	err.append (1) 	
#___________________

def Find (Sym_1, Sym_2):
 if (f[Sym_1] == None) or (f[Sym_2] == None):
 	return
 	
 g = f[Sym_1]     #  1
 g1 = f[Sym_2]    #  2
    
 n = -1	
 ind = g1.index			 
 for i in range (len(g.kerning)):
   if g.kerning[i].key == ind: 
    k = g.kerning[i].value
    n = i
 if n == -1:
  print "/"+g.name, "/"+g1.name, "---------- pair not exist"  
  err.append (1)
 	
#_________________  

print
print "===== ", f.full_name, " ====="
print ("____________________")
print ("Compar cyr-lat pairs")
print ("____________________")
print 

Compar ("A", "T", "afii10017", "afii10036") # 
Compar ("T", "A", "afii10036", "afii10017") # TA
Compar ("A", "O", "afii10017", "afii10032") # AO
Compar ("A", "C", "afii10017", "afii10035") # AC
Compar ("A", "y", "afii10017", "afii10085") # Ay
Compar ("A", "c", "afii10017", "afii10083") # A
Compar ("A", "o", "afii10017", "afii10080") # Ao
Compar ("A", "e", "afii10017", "afii10070") # Ae
Compar ("J", "A", "afii10057", "afii10017") # JA
Compar ("C", "O", "afii10035", "afii10032") # CO
Compar ("C", "C", "afii10035", "afii10035") # CC
Compar ("O", "A", "afii10048", "afii10017") # A
Compar ("O", "A", "afii10032", "afii10017") # OA
Compar ("O", "T", "afii10032", "afii10036") # OT
Compar ("O", "V", "afii10032", "afii10148") # OV
Compar ("A", "V", "afii10017", "afii10148") # AV
Compar ("P", "c", "afii10034", "afii10083") # P
Compar ("P", "e", "afii10034", "afii10070") # P
Compar ("P", "o", "afii10034", "afii10080") # P
Compar ("P", "s", "afii10034", "afii10102") # Ps
Compar ("T", "O", "afii10036", "afii10032") # TO
Compar ("T", "O", "afii10036", "afii10147") # T 
Compar ("T", "C", "afii10036", "afii10035") # TC
Compar ("T", "C", "afii10036", "afii10053") # T
Compar ("P", "A", "afii10034", "afii10017") # PA
Compar ("T", "a", "afii10036", "afii10065") # Ta 
Compar ("T", "e", "afii10036", "afii10070") # Te
Compar ("T", "e", "afii10036", "afii10070.var.accented") # Te'
Compar ("T", "o", "afii10036", "afii10080") # To
Compar ("T", "o", "afii10036", "afii10195") # T 
Compar ("T", "s", "afii10036", "afii10102") # Ts
Compar ("T", "c", "afii10036", "afii10083") # Tc
Compar ("T", "y", "afii10036", "afii10085") # Ty
Compar ("T", "x", "afii10036", "afii10087") # Tx
Compar ("X", "C", "afii10039", "afii10035") # XC
Compar ("X", "O", "afii10039", "afii10032") # XO
Compar ("X", "y", "afii10039", "afii10085") # Xy
Compar ("X", "o", "afii10039", "afii10080") # Xo
Compar ("X", "c", "afii10039", "afii10083") # X
Compar ("X", "e", "afii10039", "afii10070") # X
Compar ("x", "o", "afii10087", "afii10080") # xo
Compar ("x", "e", "afii10087", "afii10070") # xe
Compar ("y", "a", "afii10085", "afii10065") # ay
Compar ("o", "x", "afii10080", "afii10087") # ox
Compar ("c", "o", "afii10083", "afii10080") # 
Compar ("c", "c", "afii10083", "afii10083") # 
Compar ("c", "e", "afii10083", "afii10070") # e
Compar ("p", "x", "afii10082", "afii10087") # px
Compar ("p", "y", "afii10082", "afii10085") # py
Compar ("p", "y", "afii10082", "afii10085") # p
Compar ("p", "y", "afii10082", "afii10110") # py'
Compar ("o", "x", "afii10195", "afii10087") #  x
Compar ("x", "e", "afii10087", "afii10070") # xe
Compar ("x", "e", "afii10087", "afii10070.var.accented") # xe
Compar ("x", "e", "afii10087", "afii10071") # x
Compar ("x", "e", "afii10087", "afii10071.var.accented") # x
Compar ("x", "c", "afii10087", "afii10083") # xc
Compar ("x", "o", "afii10087", "afii10080.var.accented") # xc
Compar ("x", "o", "afii10087", "afii10195") # x 
Compar ("o", "y", "afii10080", "afii10085") # oy
Compar ("o", "y", "afii10080", "afii10085.var.accented") # oy'
Compar ("ellipsis", "y", "ellipsis", "afii10085") # y
Compar ("quotedblbase", "y", "quotedblbase", "afii10085") # y
Compar ("y", "o", "afii10085", "afii10080") # yo
Compar ("y", "o", "afii10085", "afii10080.var.accented") # yo
Compar ("y", "c", "afii10085", "afii10083") # yc
Compar ("y", "e", "afii10085", "afii10070") # ye
Compar ("idieresis", "idieresis", "afii10104", "afii10104") # idieresis/idieresis
Compar ("A", "quoteleft", "afii10017", "quoteleft")   # A
Compar ("A", "hyphen", "afii10017", "hyphen")   # A-
Compar ("hyphen", "A","hyphen", "afii10017")  # -A
Compar ("A", "quoteright", "afii10017", "quoteright") # A
Compar ("A", "quotedblleft", "afii10017", "quotedblleft")   # A 
Compar ("A", "quotedblright", "afii10017", "quotedblright") # A 
Compar ("quoteleft", "A", "quoteleft", "afii10017")   # A
Compar ("quoteright", "A", "quoteright", "afii10017") # A
Compar ("quotedblright", "A", "quotedblright", "afii10017") # A
Compar ("quotedblleft","A","quotedblleft", "afii10017") # A 
Compar ("O", "X", "afii10032", "afii10039")  # OX 
Compar ("O", "X", "afii10048", "afii10039")  # X
Compar ("P", "period", "afii10034", "period")  # P.
Compar ("P", "comma", "afii10034", "comma")    # P, 
Compar ("T", "hyphen", "afii10036", "hyphen")  # T-
Compar ("hyphen", "T", "hyphen", "afii10036")  # -T
Compar ("T", "emdash", "afii10036", "emdash")  # T 
Compar ("emdash", "T", "emdash", "afii10036")  #  T
Compar ("T", "period", "afii10036", "period")  # T.
Compar ("T", "comma", "afii10036", "comma")    # T,
Compar ("T", "period", "Tau", "period")  # T.
Compar ("T", "comma", "Tau", "comma")    # T,
Compar ("T", "colon", "Tau", "colon")  # T:
Compar ("T", "colon", "afii10036", "colon")  # T:
Compar ("T", "semicolon", "Tau", "semicolon")    # T,
Compar ("y", "period", "afii10085", "period") # y.
Compar ("y", "comma", "afii10085", "comma") # y,
Compar ("y", "ellipsis", "afii10085", "ellipsis") # y.
Compar ("T", "ellipsis", "afii10036", "ellipsis")  # T ...
Compar ("ellipsis", "T", "ellipsis", "afii10036")  # ... T
Compar ("P", "ellipsis", "afii10034", "ellipsis")  # P ...
Compar ("quotedblbase","T", "quotedblbase", "afii10036")   # T
Compar ("T", "p", "afii10036", "afii10082")        # Tp
Compar ("T","idieresis","afii10036","afii10104")   #T/idieresis
Compar ("T", "edieresis", "afii10036", "afii10071")        # T
Compar ("T", "guillemotright", "afii10036", "guillemotright") # T
Compar ("guillemotleft", "T","guillemotleft", "afii10036", ) # T
Compar ("A", "asterisk", "afii10017", "asterisk") # A*
Compar ("A", "trademark", "afii10017", "trademark") # A TM
Compar ("asterisk", "A", "asterisk", "afii10017") # *A
Compar ("afii10017", "afii10035", "afii10017", "afii10053") # A
Compar ("quotedblleft","T","quotedblleft","afii10036") #"T
Compar ("quotedblleft","T","quotedblleft","Tau") #"T
Compar ("quotedblright","T","quotedblright","afii10036") #"T
Compar ("quotedblright","T","quotedblright","Tau") #"T
Compar ("A","a","afii10017","afii10065")
Compar ("X","a","afii10039","afii10065")
Compar ("quotedblbase","V","quotedblbase","afii10148")
Compar ("quotedblbase","T","quotedblbase","Tau")
Compar ("quotesinglbase","T","quotesinglbase","Tau")
Compar ("ellipsis","V","ellipsis","afii10148")
Compar ("Asmall","Osmall","afii10017small","afii10032small")
Compar ("Asmall","Csmall","afii10017small","afii10035small")
Compar ("Osmall","Asmall","afii10032small","afii10017small")
Compar ("Psmall", "Asmall", "afii10034small", "afii10017small") 
Compar ("P", "a", "afii10034", "afii10065")   
Compar ("P", "c", "afii10034", "afii10083")    
Compar ("P", "e", "afii10034", "afii10070")   
Compar ("P", "o", "afii10034", "afii10080") 
Compar ("T", "n", "T", "m")
Compar ("Idieresis", "Idieresis", "afii10056", "afii10056")
Compar ("Asmall","Ysmall","afii10017small","uni04AEsmall")
Compar ("Ysmall","Asmall","uni04AEsmall","afii10017small")
Compar ("Ysmall","Asmall","Upsilonsmall","Alphasmall")
Compar ("A", "Y", "afii10017", "cyrstraightU")
Compar ("Y", "A", "cyrstraightU","afii10017")
Compar ("Asmall", "Ysmall", "afii10017small", "cyrstraightUsmall")
Compar ("Asmall", "Ysmall", "Alphasmall", "Upsilonsmall")
Compar ("Asmall", "Ysmall", "Alphasmall", "Upsilondieresissmall")
Compar ("Ysmall", "Asmall", "cyrstraightUsmall","afii10017small")
Compar ("O", "Y", "afii10032","cyrstraightU")
Compar ("Y", "O", "cyrstraightU","afii10032")
Compar ("Osmall", "Ysmall", "afii10032small","cyrstraightUsmall")
Compar ("Ysmall", "Osmall", "cyrstraightUsmall","afii10032small")
Compar ("A", "Ysmall", "afii10017","cyrstraightUsmall")
Compar ("Psmall", "period", "afii10034small","period")
Compar ("Psmall", "comma", "afii10034small","comma")
Compar ("Psmall", "ellipsis", "afii10034small","ellipsis")
Compar ("T", "Osmall", "afii10036","afii10032small")
Compar ("T", "Csmall", "afii10036","afii10035small")
Compar ("T", "Csmall", "afii10036","afii10053small")
Compar ("T", "Ssmall", "afii10036","afii10054small")
Compar ("Y", "a", "cyrstraightU","afii10065")
Compar ("Y", "aacute", "cyrstraightU","afii10065.var.accented")
Compar ("Y", "o", "cyrstraightU","afii10080")
Compar ("Y", "c", "cyrstraightU","afii10083")
Compar ("Y", "e", "cyrstraightU","afii10070")
Compar ("Y", "p", "cyrstraightU","afii10082")
Compar ("Y", "odieresis", "cyrstraightU","cyrodieresis")
Compar ("Y", "period", "cyrstraightU","period")
Compar ("Y", "comma", "cyrstraightU","comma")
Compar ("Y", "ellipsis", "cyrstraightU","ellipsis")
Compar ("Y", "semicolon","cyrstraightU","semicolon")
Compar ("Y", "colon","cyrstraightU","colon")
Compar ("Y", "x","cyrstraightU","afii10087")
Compar ("Y", "x","cyrstraightU","cyrhadesc")
Compar ("Y", "Hsmall","cyrstraightU","afii10031small")
Compar ("Y", "Asmall","cyrstraightU","afii10017small")
Compar ("Osmall", "Tsmall","afii10032small","afii10036small")
Compar ("Tsmall", "Csmall","afii10036small","afii10035small")
Compar ("Tsmall", "Osmall","afii10036small","afii10032small")
Compar ("o", "v","afii10195","afii10196")
Compar ("o", "x", "afii10066","afii10087")
Compar ("y", "o","afii10085","afii10080")
Compar ("y", "o","afii10085","afii10195")
Compar ("o", "y","afii10195","afii10085")
Compar ("parenleft","J","parenleft","afii10057")
Compar ("h", "y","afii10108","afii10085")

# 
Compar ("T", "A", "Tau","Alpha")
Compar ("A", "T", "Alpha","Tau")
Compar ("A", "hyphen","Alpha","hyphen")
Compar ("hyphen", "A","hyphen","Alpha")
Compar ("A", "T", "Lambda","Tau")
Compar ("T", "A", "Tau","Lambda")
Compar ("T", "O", "Tau","Omicron")
Compar ("hyphen", "T","hyphen", "Tau")  # -T
Compar ("T", "hyphen","Tau", "hyphen")  # T-
Compar ("afii10020","afii10080","Gamma","omicron")
Compar ("afii10020","afii10080","Gamma","alpha")
Compar ("afii10020","afii10080","Gamma","alphatonos")
Compar ("afii10020","comma","Gamma","comma")
Compar ("afii10020","period","Gamma","period")
Compar ("afii10020","ellipsis","Gamma","ellipsis")
Compar ("O", "T", "Omicron","Tau")
Compar ("Y", "A", "Upsilon","Alpha")
Compar ("A", "Y", "Alpha","Upsilon")
Compar ("K", "O", "Kappa","Omicron")
Compar ("X", "O", "Chi","Omicron")
Compar ("O", "X", "Omicron","Chi")
Compar ("K", "O", "Kappa","Omicron")
Compar ("Y", "O", "Upsilon","Omicron")
Compar ("O", "Y", "Omicron","Upsilon")
Compar ("P", "A", "Rho", "Alpha")  # PA
Compar ("P", "period", "Rho", "period")  # P.
Compar ("P", "comma", "Rho", "comma")  # P,
Compar ("P", "ellipsis", "Rho", "ellipsis")  # P...
Compar ("afii10038", "afii10017", "Phi","Alpha")
Compar ("afii10017", "afii10038", "Alpha","Phi")
Compar ("afii10038", "afii10017", "Phi","Lambda")
Compar ("afii10039","afii10038","Chi","Phi")
Compar ("afii10038","afii10039","Phi","Chi")
Compar ("afii10017", "afii10038", "Lambda","Phi")
Compar ("T", "c", "Tau","sigma1")
Compar ("T", "o", "Tau","omicron")
Compar ("quotedblbase", "Y", "quotedblbase","Upsilon")
Compar ("ellipsis", "Y", "ellipsis","Upsilon")
Compar ("h", "y", "cyrh","afii10085")
Compar ("ellipsis", "Y", "ellipsis","cyrstraightU")
Compar ("quotedblbase", "Y", "quotedblbase","cyrstraightU")
Compar ("Y", "edieresis", "cyrstraightU","afii10071")
Compar ("Y", "odieresis", "cyrstraightU","cyrodieresis")
Compar ("Y", "y", "cyrstraightU","afii10085")
Compar ("X", "hyphen", "afii10039","hyphen")
Compar ("hyphen", "X", "hyphen","afii10039")
Compar ("O","Y","Theta", "Upsilon")
Compar ("Y","O","Upsilon", "Theta")
Compar ("B","Y","afii10019", "cyrstraightU")
Compar ("B","Y","Beta", "Upsilon")
Compar ("Osmall","Xsmall","afii10032small","afii10039small")
Compar ("Xsmall","Osmall","afii10039small","afii10032small")
Compar ("Xsmall","small","afii10039small","afii10035small")
Compar ("Xsmall","Osmall","afii10039small","cyrObarsmall")
Compar ("Xsmall","Osmall","afii10039small","cyrOdieresissmall")
Compar ("Xsmall","Osmall","afii10039small","afii10147small")
Compar ("Xsmall","Osmall","Chismall","Omicronsmall")
Compar ("Xsmall","Csmall","afii10039small","cyrEstailsmall")
Compar ("Xsmall","Csmall","afii10039small","afii10035small")
Compar ("Xsmall","Csmall","afii10039small","afii10053small")
Compar ("Y","Osmall","cyrstraightU","afii10032small")
Compar ("Y","Asmall","cyrstraightU","afii10017small")
Compar ("Y", "C", "cyrstraightU","afii10035")
Compar ("Y", "O", "cyrstraightU","afii10032")
Compar ("O", "Y", "afii10032","cyrstraightU")
Compar ("P", "X", "afii10034","afii10039")
Compar ("afii10020", "ellipsis", "Gamma","ellipsis")
Compar ("afii10020", "period", "Gamma","period")
Compar ("afii10020", "comma", "Gamma","comma")
Compar ("A", "asterisk", "Alpha","asterisk")
Compar ("asterisk", "A", "asterisk","Alpha")
Compar ("quotedblleft", "A", "quotedblleft","Alpha")
Compar ("quotedblright", "A", "quotedblright","Alpha")
Compar ("X", "o", "Chi","omicron")
Compar ("guillemotleft", "Y", "guillemotleft","Upsilon")
Compar ("guilsingllef", "Y", "guilsinglleft","Upsilon")
Compar ("Y", "o", "Upsilon","omicron")
Compar ("Y", "guillemotright", "Upsilon","guillemotright")
Compar ("Y", "guilsinglright", "Upsilon","guilsinglright")
Compar ("Y", "guilsinglright", "Upsilondieresis","guilsinglright")
Compar ("Y", "guillemotright", "Upsilontonos","guillemotright")
Compar ("Y", "guilsinglright", "Upsilontonos","guilsinglright")
Compar ("guillemotleft", "T","guillemotleft", "Tau", ) # T
Compar ("T", "guillemotright", "Tau", "guillemotright")  # T 
Compar ("A", "O", "Alpha","Omicron")
Compar ("O", "A", "Omicron","Alpha")
Compar ("A", "O", "Lambda","Omicron")
Compar ("O", "A", "Omicron","Lambda")
Compar ("A", "O", "Alpha","Theta")
Compar ("O", "A", "Theta","Alpha")
Compar ("A", "O", "Lambda","Theta")
Compar ("O", "A", "Theta","Lambda")
Compar ("Osmall", "Ysmall", "Omicronsmall","Upsilonsmall")
Compar ("Ysmall", "Osmall", "Upsilonsmall","Omicronsmall")
Compar ("afii10036", "afii10038", "Tau","Phi")
Compar ("afii10038", "afii10036","Phi","Tau")
Compar ("afii10020","afii10038","Gamma","Phi")
Compar ("afii10020", "afii10017", "Gamma","Alpha")
Compar ("Psmall", "Asmall", "Rhosmall", "Alphasmall")
Compar ("Osmall","Xsmall","Omicronsmall","Chismall")
Compar ("Osmall", "Asmall", "Omicronsmall", "Alphasmall")
Compar ("Asmall","Osmall","Alphasmall","Omicronsmall")
Compar ("Osmall", "Asmall", "Omicronsmall", "Lambdasmall")
Compar ("Asmall","Osmall","Lambdasmall","Omicronsmall")
Compar ("afii10038small","afii10017small","Phismall","Alphasmall")
Compar ("afii10017small","afii10038small","Alphasmall","Phismall")
Compar ("afii10020","afii10017small","Gamma","Alphasmall")
Compar ("afii10020small","afii10017small","Gammasmall","Alphasmall")
Compar ("afii10020small","afii10017small","Gammasmall","Lambdasmall")
Compar ("afii10039","afii10038small","Chi","Phismall")
Compar ("Asmall", "Tsmall", "Alphasmall", "Tausmall")
Compar ("Tsmall","Asmall", "Tausmall", "Alphasmall")
Compar ("Psmall", "ellipsis", "Rhosmall", "ellipsis")
Compar ("Psmall", "period", "Rhosmall", "period")
Compar ("Psmall", "comma", "Rhosmall", "comma")
Compar ("Ysmall", "comma", "Upsilonsmall", "comma")
Compar ("Ysmall", "period", "Upsilonsmall", "period")
Compar ("Y", "Zsmall", "Upsilon", "Zetasmall")
Compar ("Y", "Hsmall", "Upsilon", "Etasmall")
Compar ("Ksmall", "Osmall", "Kappasmall", "Omicronsmall")
Compar ("afii10038small", "afii10039small", "Phismall", "Chismall")
Compar ("afii10039small", "afii10038small", "Chismall","Phismall")

if f.font_style & 1:
	Compar ("X","u","afii10039","afii10074")
	Compar ("A","u","afii10017","afii10074")
	Compar ("T", "n", "afii10036", "afii10081")        # Tn ( )
	Compar ("T", "u", "afii10036", "afii10074")        # Tu ( )
	Compar ("T", "m", "afii10036", "afii10084")        # Tm ( )
	Compar ("n", "y", "afii10081", "afii10085") 
	Compar ("Y", "n", "cyrstraightU", "afii10081")
else:
	Compar ("a", "y", "afii10065", "afii10085")        # ay	

print
if err == ("Asmall","Ysmall"):
	print "All checked pairs are correct";
else:
	print	len (err), "error(s)"

print ("____________________")
print ("Find pairs")
print ("____________________")
print 
err = []

Find ("T", "AE") 
Find ("F", "AE") 
Find ("P", "AE") 
Find ("W", "AE")
Find ("W", "ellipsis")
Find ("F", "ellipsis")
Find ("V", "ellipsis")
Find ("V", "AE")
Find ("V", "colon")
Find ("V", "semicolon")
Find ("Y", "colon")
Find ("Y", "semicolon")
Find ("O", "AE")
Find ("U", "AE") 
Find ("D", "AE")
Find ("Thorn", "ellipsis")
Find ("Thorn", "period")
Find ("Thorn", "comma")
Find ("Thorn", "T")
Find ("Thorn", "V")
Find ("Thorn", "W")
Find ("Thorn", "Y")
Find ("Thorn", "X")
Find ("quotedblbase", "V")
Find ("quotedblbase", "W")
Find ("quotedblbase", "Y")
Find ("quotedblleft", "AE") 
Find ("quotedblright", "AE") 
Find ("quoteright", "AE")
Find ("quoteleft", "AE")
Find ("asterisk", "AE")
Find ("afii10050","colon")
Find ("afii10050","semicolon")
Find ("afii10037","colon")
Find ("afii10037","semicolon")
Find ("seven","period")
Find ("seven","comma")
Find ("afii10050","comma")
Find ("afii10050","period")
Find ("afii10050","ellipsis")
Find ("afii10098","comma")
Find ("afii10098","period")
Find ("afii10098","ellipsis")
Find ("r","ellipsis")
Find ("r","comma")
Find ("ellipsis","afii10041")
Find ("ellipsis","afii10089")
Find ("afii10017","afii10089")
Find ("afii10085","afii10077")
Find ("afii10068","afii10077")
Find ("afii10085","afii10077")
if not f.font_style & 1:
	Find ("afii10084","ellipsis")
	Find ("ellipsis","afii10084")
	Find ("afii10068","afii10077")
if err == []:
	print "All checked pairs are correct"

fl.UpdateFont()